unit UnitImage;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Menus, Series, TeEngine, TeeProcs,
  Chart,UnitCommon,UnitDFT;

type
  TForm2 = class(TForm)
    PanelCtrl: TPanel;
    StatusBar1: TStatusBar;
    PanelImage: TPanel;
    PanelPattern: TPanel;
    PanelMnemo: TPanel;
    MainMenu1: TMainMenu;
    NF: TMenuItem;
    ND: TMenuItem;
    NPT: TMenuItem;
    ImageData: TImage;
    ImagePattern: TImage;
    OpenDialog1: TOpenDialog;
    PanelLeft: TPanel;
    Splitter1: TSplitter;
    ComboBoxY: TComboBox;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Label2: TLabel;
    CheckBoxMH: TCheckBox;
    NPF: TMenuItem;
    ButtonCompare: TButton;
    ButtonCorr: TButton;
    RichEdit1: TRichEdit;
    CheckBoxBinar: TCheckBox;
    EditBinar: TEdit;
    ButtonBin: TButton;
    procedure ResizeImage(Im:Timage);
    procedure DrawImage(Im:Timage;Data:TScart; MH:tscart; kview:boolean);
    procedure FormResize(Sender: TObject);
    procedure NPTClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ComboBoxYChange(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure NPFClick(Sender: TObject);
    procedure ButtonCompareClick(Sender: TObject);
    procedure Compare(dat,pat:TImageSound; var pr:integer);
    procedure Correlation(dat,pat:TImageSound);
    procedure ButtonCorrClick(Sender: TObject);
    procedure CheckBoxBinarClick(Sender: TObject);
    procedure CheckBoxMHClick(Sender: TObject);
    procedure ButtonBinClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  IW,IH:integer;
  scaley:integer;
  Brightness:integer;
  BinarLevel:integer;
implementation

uses UnitMain;

{$R *.dfm}



procedure TForm2.ResizeImage(Im:Timage);
begin
 PanelImage.Left:=0;
 PanelImage.width:=PanelLeft.Width div 2 - 2 ;
 PanelPattern.Left:=PanelImage.width+2;
 PanelPattern.width:=PanelImage.width;

 PanelImage.Height:=PanelLeft.Height - 2 ;
 PanelPattern.Height:=PanelImage.Height;


 Im.Picture.Bitmap.Width := PanelImage.width;
 Im.Picture.Bitmap.Height:= PanelImage.height;
 IW:=40;
 IH:=20;
 with Im.Picture.Bitmap.Canvas do begin
    Pen.Style   := psSolid;
    Pen.Color   := clwhite;
    Brush.Style := bsSolid;
    Brush.Color := $CCCCCC;
  end;
  Im.Picture.Bitmap.Canvas.Rectangle(0,0,Im.width,Im.height);
  Im.Picture.Bitmap.Canvas.Pen.Color   := clblack;
  Im.Picture.Bitmap.Canvas.Brush.Color := $FFFFFF;
  Im.Picture.Bitmap.Canvas.Rectangle(IW,0,Im.width,Im.height-IH);

end;

procedure TForm2.DrawImage(Im:Timage;Data:TScart; MH:tscart; kview:boolean);
 const maskz=$FFFF00;
 var
 k,i:integer;
 x,y:integer;
 w,h:integer;
 sx,sy:real;
 xw:integer;
 z,zc:integer;
 yax,xax:integer;
 hz:integer;

begin

 w:=Im.Width - IW;
 h:=Im.Height - IH;
 sx:=w/Envelope.Count_frame;
 sy:=h/DFT_kmax*scaley;

 Im.Picture.Bitmap.Canvas.Brush.color:=$CCCCCC;
 for i:=0 to Envelope.Count_frame - 1 do
  begin
    x:= trunc(i*sx)+IW;
    if i mod 5 = 0 then
    begin
      Im.Picture.Bitmap.Canvas.MoveTo(x,h+6);
      Im.Picture.Bitmap.Canvas.LineTo(x,h+2);
      Im.Picture.Bitmap.Canvas.TextOut(x,h+6,inttostr(i));
    end;

    for k:=0 to DFT_kmax -1 do
    begin
      y:= h - trunc(k*sy);
      zc:=byte(Data[i][k]);
      zc:=zc+Brightness;
      if zc > 255 then zc :=255;
      if zc < 0 then zc:=0;

      z:=(zc shl 8) + (zc shl 16) or zc;//

      if CheckBoxMH.Checked then
        if (mh[i][k] > 0) and (Data[i][k] > Envelope.LevelMax) then z := $0000FF;
      if CheckBoxBinar.Checked then if Data[i][k] > BinarLevel then z:=$ffffff else z:=0;
      Im.Picture.Bitmap.Canvas.Pen.Color   := z;
      for xw:=0 to trunc(sx) do
      begin
        Im.Picture.Bitmap.Canvas.MoveTo(x+xw,y);
        Im.Picture.Bitmap.Canvas.LineTo(x+xw,trunc(y-sy));
      end;
      if i = 0 then
      begin
        xax:=x - 6;
        if k mod 20 = 0 then
        begin
          if kview then hz:=k else hz:=round(k*discret/DFT.nmax);
          Im.Picture.Bitmap.Canvas.MoveTo(xax,y);
          Im.Picture.Bitmap.Canvas.LineTo(xax+3,y);
          if k < (DFT_kmax div scaley) then Im.Picture.Bitmap.Canvas.TextOut(xax-30,y-10,inttostr(hz));
        end;
     end;
    end;//k
  end;

end;

procedure TForm2.FormResize(Sender: TObject);
begin
  if ExitProgram then exit;

  ResizeImage(ImageData);
  DrawImage(ImageData,Scart,MaxHarm,true);
  ResizeImage(ImagePattern);
  DrawImage(ImagePattern,ImPat.Data,ImPat.MaxHarm,false);
end;


procedure TForm2.NPFClick(Sender: TObject);
var
 i,k:integer;
 AppPath:string;
 siz1,siz2,siz3:integer;
 fs:TFileStream;
begin
 AppPath := AnsiUpperCase(ExtractFilePath(ParamStr(0)));
 OpenDialog1.InitialDir:=AppPath;
 OpenDialog1.Filter:='BIN|*.BIN|All|*.*';

 siz1:=DFT_kmax*sizeof(Scart[0][0]);
 siz2:=Envelope.Count_frame*sizeof(Envelope.Start_dim[0]);
 siz3:=DFT_kmax*sizeof(single);

 if OpenDialog1.Execute then
  begin
    fs := TFileStream.Create(Opendialog1.FileName, fmOpenRead or fmShareDenyWrite);
    try
     for i:=0 to Envelope.Count_frame - 1 do fs.ReadBuffer(ImPat.data[i],siz1);
     for i:=0 to Envelope.Count_frame - 1 do fs.ReadBuffer(ImPat.maxharm[i],siz1);
     fs.ReadBuffer(ImPat.Start_dim[0],siz2);
     fs.ReadBuffer(ImPat.Stop_dim[0],siz2);
     fs.ReadBuffer(ImPat.Power[0],siz2);
     fs.ReadBuffer(ImPat.AvgHarm[0],siz2);
     fs.ReadBuffer(ImPat.AvgFrame[0],siz3);

     Envelope.Find_maxHarm(ImPat.Data,ImPat.MaxHarm);
     DrawImage(ImagePattern,ImPat.Data,ImPat.MaxHarm,false);
    finally
    FreeAndNil(fs);
    end;
  end;
end;


procedure TForm2.NPTClick(Sender: TObject);
var
 i,k,l:integer;
 fpat:TextFile;
 st,sint:string;
 AppPath:string;
 sizeline:integer;
 StringList: TStrings;
begin

 AppPath := AnsiUpperCase(ExtractFilePath(ParamStr(0)));
 OpenDialog1.InitialDir:=AppPath;
 OpenDialog1.Filter:='DAT|*.DAT|All|*.*';
 if OpenDialog1.Execute then
  begin
    StringList := TStringList.Create;
    StringList.Delimiter:=#9;
    st:=Opendialog1.FileName;
    AssignFile(fpat, st);
    Reset(fpat);
    i:=0;
    k:=0;


    for i:=0 to Envelope.Count_frame - 1 do
    begin
      readln(fpat,st);
      StringList.DelimitedText:= st;
      for k:=0 to DFT_kmax-1 do  ImPat.Data[i][k]:=strtoint(StringList[k]);
      if StringList.Count > DFT_kmax + 1 then
      begin
        ImPat.Start_dim[i]:=strtoint(StringList[k]);
        ImPat.Stop_dim[i]:=strtoint(StringList[k+1]);
      end;
    end;

    CloseFile(fpat);
    StringList.Free;
    Envelope.Find_maxHarm(ImPat.Data,ImPat.MaxHarm);
    DrawImage(ImagePattern,ImPat.Data,ImPat.MaxHarm,false);
  end;

end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  FormImage:=true;
  ComboBoxY.ItemIndex:=0;
  scaley:=ComboBoxY.ItemIndex+1;
  Form2.Width:=700;
  Form2.Height:=500;
  Form2.Left:=FmainLeft-50;
  Form2.Top:=FmainTop-50;
  Brightness:=0;
  BinarLevel:=5;
  EditBinar.Text:=inttostr(BinarLevel);
end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 FormImage:=false;
end;

procedure TForm2.ComboBoxYChange(Sender: TObject);
begin
 scaley:=ComboboxY.ItemIndex +1;
 FormResize(self);
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  Brightness:=Brightness+10;
  if  Brightness > 255 then Brightness:=255;
  DrawImage(ImageData,Scart,maxHarm,true);
  DrawImage(ImagePattern,ImPat.Data,ImPat.MaxHarm,false);
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
  Brightness:=Brightness-10;
  if  Brightness < 0 then Brightness:=0;
  DrawImage(ImageData,Scart,maxharm,true);
  DrawImage(ImagePattern,ImPat.Data,ImPat.MaxHarm,false);
end;



procedure TForm2.Compare(dat,pat:TImageSound; var pr:integer);
var k,n,np:integer;
 start_posX_dat:integer;
 stop_posX_dat:integer;
 start_posX_pat:integer;
 stop_posX_pat:integer;

 max_harm_dat:integer;
 max_harm_pat:integer;
 old_max_harm:integer;

 frames:integer;
 ddd,ppp:integer;
 sum_frame:integer;


 x,y:integer;
 w,h:integer;
 sx,sy:real;
 xw:integer;
 z,zc:integer;
 yax,xax:integer;
 hz:integer;


begin

 w:=ImageData.Width - IW;
 h:=ImageData.Height - IH;
 sx:=w/Envelope.Count_frame;
 sy:=h/DFT_kmax*scaley;



 start_posX_dat:=0;
 stop_posX_dat:=0;
 start_posX_pat:=0;
 stop_posX_pat:=0;


 frames:=Length(dat.Start_dim);
 for n:=0 to frames-1 do //         X
 begin
  if (dat.Start_dim[n] > 0) and (start_posX_dat = 0)  then start_posX_dat:=n;
  if (pat.Start_dim[n] > 0) and (start_posX_pat = 0)  then start_posX_pat:=n;
  if (dat.Stop_dim[n] > 0) and (stop_posX_dat < frames) then stop_posX_dat:= n;
  if (pat.Stop_dim[n] > 0) and (stop_posX_pat < frames) then stop_posX_pat:= n;
 end;

 max_harm_dat:=0;
 max_harm_pat:=0;
 old_max_harm:=0;


 for n:=0 to frames-1 do //       
 begin
//  x:= trunc(n*sx)+IW;
  for k:=DFT_kmax-1 downto 1 do
   if (dat.MaxHarm[n][k] > 0)then
      begin
        old_max_harm:=k;
        break;
      end;
  if old_max_harm > max_harm_dat then max_harm_dat:=old_max_harm;
 end;//for


 sum_frame:=0;
 np:=start_posX_pat;

 ImageData.Picture.Bitmap.Canvas.Pen.Color   := clyellow;

 for n:=start_posX_dat to stop_posX_dat do
 begin
   x:= trunc(n*sx)+IW;
   for k:=1 to max_harm_dat do
   begin
    y:= h - trunc(k*sy);
    if Dat.MaxHarm[n][k] > 0 then
     begin
        ddd:=Dat.Data[n][k];
        ppp:=Pat.Data[np][k];
        if Pat.MaxHarm[np][k] > 0 then
        begin
          inc(sum_frame);

          for xw:=0 to trunc(sx) do
          begin
            ImageData.Picture.Bitmap.Canvas.MoveTo(x+xw,y);
            ImageData.Picture.Bitmap.Canvas.LineTo(x+xw,trunc(y-sy));
          end;

        end;
     end
   end;
   inc(np);
 end;
 pr:=sum_frame;


end;

procedure TForm2.Correlation(dat,pat:TImageSound);
var k,n,i,np,sh:integer;
 start_posX_dat:integer;
 stop_posX_dat:integer;
 start_posX_pat:integer;
 stop_posX_pat:integer;

 max_harm_dat:integer;
 max_harm_pat:integer;
 old_max_harm:integer;

 frames:integer;

 sum,dx,dy,mx,my:single;
 cov:integer;

 x,y:integer;
 w,h:integer;
 sx,sy:real;
 st:string;

 sum_cov:single;
 max_cov:single;

 kmin,kmax:integer;
 asum,adx,ady,amx,amy:array[0..3] of single;
 acov: array [0..3] of integer;
 asum_cov: array[0..3] of integer;
 ast:array [0..3] of string;
 bas:integer;
begin

 w:=ImageData.Width - IW;
 h:=ImageData.Height - IH;
 sx:=w/Envelope.Count_frame;
 sy:=h/DFT_kmax*scaley;
 ImagePattern.Picture.Bitmap.Canvas.Pen.Color   := clyellow;

 start_posX_dat:=0;
 stop_posX_dat:=0;
 start_posX_pat:=0;
 stop_posX_pat:=0;

 frames:=Length(dat.Start_dim);


 for n:=0 to frames-1 do //       
 begin
  for k:=DFT_kmax-1 downto 1 do
   if (dat.MaxHarm[n][k] > 0)then
      begin
        old_max_harm:=k;
        break;
      end;
  if old_max_harm > max_harm_dat then max_harm_dat:=old_max_harm;
 end;//for

 //    ,   
 for n:=0 to frames-1 do //         X
 begin
  if (dat.Start_dim[n] > 0) and (start_posX_dat = 0)  then start_posX_dat:=n;
  if (pat.Start_dim[n] > 0) and (start_posX_pat = 0)  then start_posX_pat:=n;
  if (dat.Stop_dim[n] > 0) and (stop_posX_dat < frames) then stop_posX_dat:= n;
  if (pat.Stop_dim[n] > 0) and (stop_posX_pat < frames) then stop_posX_pat:= n;
 end;
 //      
 //    ?    !
 //        
{
 RichEdit1.Lines.Add('****Vert******');
 for sh:=-3 to 3 do
 begin
  np:=start_posX_pat+sh;
  if np < 0 then np:=0;
  if np > frames-1 then np:=frames-1;

  st:='';
//  x:= trunc(np*sx)+IW;
//  ImagePattern.Picture.Bitmap.Canvas.MoveTo(x,0);
//  ImagePattern.Picture.Bitmap.Canvas.LineTo(x,h);
  sum_cov:=0;
  max_cov:=0;
  for n:=start_posX_dat to stop_posX_dat do
   begin
    sum:=0;
    dx:=0;
    dy:=0;
    for k:=0 to DFT_kmax - 1 do //3
    begin
     mx:=dat.Data[n][k] - dat.avgharm[n];//Envelope.Count_frame
     my:=pat.Data[np][k] - pat.avgharm[np];//Envelope.Count_frame
     sum:=sum + mx*my;
     dx:=dx+mx*mx;
     dy:=dy+my*my;
    end;
    if (dx=0) or (dy=0) then cov :=0
     else  cov:= round(sum /(sqrt(dx)*sqrt(dy))*100);//   
    sum_cov:=sum_cov+cov;
    st:=st+inttostr(cov)+',';
    inc(np);
    if np < 0 then np:=0;
    if np > frames-1 then np:=frames-1;
  end;
  RichEdit1.Lines.Add(st+' '+inttostr(round(sum_cov/(stop_posX_dat-start_posX_dat+1))));
 end;//shift
}
{
 //       
 RichEdit1.Lines.Add('****Hor******');
 for sh:=-1 to 1 do
 begin
  sum:=0;
  dx:=0;
  dy:=0;
  st:='';
  for k:= 0 to DFT_kmax - 1 do
  begin
    np:=sh;
    for n:=0 to frames-1 do
    begin
     mx:=dat.Data[n][k] - dat.avgframe[k];
     if (np > -1) and (np < frames) then my:=pat.Data[np][k] - pat.avgframe[k] else my:=0;
     sum:=sum + mx*my;
     dx:=dx+mx*mx;
     dy:=dy+my*my;
     inc(np);
    end;
    if (dx=0) or (dy=0) then cov :=0
     else  cov:= round(sum /(sqrt(dx)*sqrt(dy))*100);//   
    RichEdit1.Lines.Add(inttostr(k)+':'+inttostr(cov));
  end;
 end;//shift
}

 kmin:=5;kmax:=200;
 bas:= stop_posX_dat-start_posX_dat+1;
 Dat.CreateDataNext;
 Pat.CreateDataNext;
 for k:=0 to 3 do
 begin
  ast[k]:='';
  asum_cov[k]:=0;
 end;
 np:=start_posX_pat;
 sum_cov:=0;
 for n:=start_posX_dat to stop_posX_dat do
 begin
   for k:=0 to 3 do
   begin
     dat.avg[k]:=0;
     adx[k]:=0;
     ady[k]:=0;
     asum[k]:=0;
   end;

   for k:=kmin to kmax do
   begin
    dat.avg[0] := dat.avg[0]+dat.Data[n][k];
    dat.avg[1] := dat.avg[1]+dat.DataUp[n][k];
    dat.avg[2] := dat.avg[2]+dat.DataRight[n][k];
    dat.avg[3] := dat.avg[3]+dat.DataDown[n][k];

    pat.avg[0] := pat.avg[0]+pat.Data[np][k];
    pat.avg[1] := pat.avg[1]+pat.DataUp[np][k];
    pat.avg[2] := pat.avg[2]+pat.DataRight[np][k];
    pat.avg[3] := pat.avg[3]+pat.DataDown[np][k];
   end;
   dat.avg[0]:=dat.avg[0]/(kmax-kmin+1);
   dat.avg[1]:=dat.avg[1]/(kmax-kmin+1);
   dat.avg[2]:=dat.avg[2]/(kmax-kmin+1);
   dat.avg[3]:=dat.avg[3]/(kmax-kmin+1);

   pat.avg[0]:=pat.avg[0]/(kmax-kmin+1);
   pat.avg[1]:=pat.avg[1]/(kmax-kmin+1);
   pat.avg[2]:=pat.avg[2]/(kmax-kmin+1);
   pat.avg[3]:=pat.avg[3]/(kmax-kmin+1);
//  ...

   for k:=kmin to kmax do
   begin
    amx[0]:=dat.Data[n][k]      - dat.avg[0];
    amx[1]:=dat.DataUp[n][k]    - dat.avg[1];
    amx[2]:=dat.DataRight[n][k] - dat.avg[2];
    amx[3]:=dat.DataDown[n][k]  - dat.avg[3];

    amy[0]:=pat.Data[np][k]      - pat.avg[0];
    amy[1]:=pat.DataUp[np][k]    - pat.avg[1];
    amy[2]:=pat.DataRight[np][k] - pat.avg[2];
    amy[3]:=pat.DataDown[np][k]  - pat.avg[3];

    for i:=0 to 3 do
    begin
     asum[i]:=asum[i] + amx[i]*amy[i];
     adx[i]:=adx[i]+amx[i]*amx[i];
     ady[i]:=ady[i]+amy[i]*amy[i];
    end;
   end;//k
   for i:=0 to 3 do
   begin
       if (adx[i]=0) or (ady[i]=0) then acov[i] :=0
                                   else acov[i]:= round(asum[i] /(sqrt(adx[i])*sqrt(ady[i]))*100);
       asum_cov[i]:=asum_cov[i] + acov[i];
       ast[i]:=ast[i]+inttostr(acov[i])+',';
   end;
   inc(np);
//   for i:=0 to 3 do ast[i]:=ast[i]+inttostr(acov[i])+',';
 end;//n
 RichEdit1.Lines.Add('***********');
 for i:=0 to 3 do
 begin
  RichEdit1.Lines.Add(ast[i]+': '+inttostr(round(asum_cov[i]/bas)));
 end;
// RichEdit1.Lines.Add(inttostr(round(sum_cov/bas)));
end;


procedure TForm2.ButtonCompareClick(Sender: TObject);
var res:integer;
begin
 Compare(ImDat,ImPat,res);
 RichEdit1.Lines.Add('Compare:'+inttostr(res)+'/'+inttostr(ActivHarm));

end;

procedure TForm2.ButtonCorrClick(Sender: TObject);
begin
  Correlation(ImDat,ImPat);
end;

procedure TForm2.CheckBoxBinarClick(Sender: TObject);
begin
 DrawImage(ImageData,Scart,maxHarm,true);
 DrawImage(ImagePattern,ImPat.Data,ImPat.MaxHarm,false);
end;

procedure TForm2.CheckBoxMHClick(Sender: TObject);
begin
 DrawImage(ImageData,Scart,maxHarm,true);
 DrawImage(ImagePattern,ImPat.Data,ImPat.MaxHarm,false);
end;

procedure TForm2.ButtonBinClick(Sender: TObject);
begin
 BinarLevel:=strtoint(EditBinar.text);
 DrawImage(ImageData,Scart,maxHarm,true);
 DrawImage(ImagePattern,ImPat.Data,ImPat.MaxHarm,false);

end;

end.
